'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DatePicker = require('material-ui/DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  /** Hash of props to from_date picker */
  fromDatePicker: _propTypes2.default.object,
  /** Hash of props to to_date picker */
  toDatePicker: _propTypes2.default.object,
  /** Function triggered when range is selected */
  onSelectedRange: _propTypes2.default.func
};

var defaultProps = {
  fromDatePicker: {},
  toDatePicker: {}
};

/**
 * Generic Date picker of ranges component.
 *
 * @author [César Parra](https://github.com/cparram)
 */

var MuiDateRangePicker = function (_React$Component) {
  _inherits(MuiDateRangePicker, _React$Component);

  function MuiDateRangePicker() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MuiDateRangePicker);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MuiDateRangePicker.__proto__ || Object.getPrototypeOf(MuiDateRangePicker)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      fromDate: null
    }, _this.open = function () {
      _this.fromDate.openDialog();
    }, _this.onFromDateChange = function (_, date) {
      _this.setState({
        fromDate: date
      });

      _this.toDate.openDialog();
    }, _this.onToDateChange = function (_, date) {
      var fromDate = (0, _moment2.default)(_this.state.fromDate);
      var toDate = (0, _moment2.default)(date);

      var onSelectedRange = _this.props.onSelectedRange;
      onSelectedRange && onSelectedRange(fromDate, toDate);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  /**
   * Function used to open date picker.
   *
   * @public
   */


  /**
   * Function used when from date change.
   */


  /**
   *  Callback function triggered when to date change.
   *  This set formsy value.
   */


  _createClass(MuiDateRangePicker, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var styles = getStyles(this.props);

      var _props = this.props,
          fromDatePicker = _props.fromDatePicker,
          toDatePicker = _props.toDatePicker;


      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_DatePicker2.default, _extends({
          id: 'MuiDateRangePicker_Datepicker_0',
          onChange: this.onFromDateChange,
          style: styles.picker,
          ref: function ref(_ref2) {
            return _this2.fromDate = _ref2;
          }
        }, fromDatePicker)),
        _react2.default.createElement(_DatePicker2.default, _extends({
          id: 'MuiDateRangePicker_Datepicker_1',
          onChange: this.onToDateChange,
          style: styles.picker,
          ref: function ref(_ref3) {
            return _this2.toDate = _ref3;
          }
        }, toDatePicker))
      );
    }
  }]);

  return MuiDateRangePicker;
}(_react2.default.Component);

MuiDateRangePicker.displayName = 'MuiDateRangePicker';


MuiDateRangePicker.propTypes = propTypes;
MuiDateRangePicker.defaultProps = defaultProps;

// eslint-disable-next-line no-unused-vars
var getStyles = function getStyles(props) {
  return {
    picker: {
      display: 'none'
    }
  };
};

exports.default = MuiDateRangePicker;