'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _List = require('material-ui/List');

var _Subheader = require('material-ui/Subheader');

var _Subheader2 = _interopRequireDefault(_Subheader);

var _radioButtonUnchecked = require('material-ui/svg-icons/toggle/radio-button-unchecked');

var _radioButtonUnchecked2 = _interopRequireDefault(_radioButtonUnchecked);

var _radioButtonChecked = require('material-ui/svg-icons/toggle/radio-button-checked');

var _radioButtonChecked2 = _interopRequireDefault(_radioButtonChecked);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  /** Functrion triggered when a date is selected */
  onChange: _propTypes2.default.func,
  /** The title of selector */
  title: _propTypes2.default.string.isRequired,
  /** The list of dates to select */
  dates: _propTypes2.default.array.isRequired,
  customDateSelectorTitle: _propTypes2.default.string,
  children: _propTypes2.default.element
};

var defaultProps = {
  title: 'Fecha',
  dates: [],
  customDateSelectorTitle: 'Personalizado'
};

/**
 * Component used to render filter for meetings
 *
 * @author [César Parra](https://github.com/cparram)
 */

var MuiDateSelector = function (_React$Component) {
  _inherits(MuiDateSelector, _React$Component);

  function MuiDateSelector() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MuiDateSelector);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MuiDateSelector.__proto__ || Object.getPrototypeOf(MuiDateSelector)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      selected: null,
      customRange: null
    }, _this.format = 'DD/MM/YYYY', _this.selectDate = function (selected) {
      _this.setState({
        selected: selected
      });
    }, _this.listItemSecondaryText = function (fromDate, toDate) {
      var formatted = [fromDate, toDate].map(function (date) {
        return date.format(_this.format);
      });
      return formatted.filter(function (d, i, l) {
        return l.indexOf(d) === i;
      }).join(' — ');
    }, _this.onCustomRangeSelected = function (fromDate, toDate) {
      _this.setState(function (prevState) {
        return {
          selected: prevState.selected < 0 ? prevState.selected - 1 : -1,
          customRange: [fromDate, toDate]
        };
      });
    }, _this.rangeSelectorRef = function (ref) {
      return _this.rangeSelector = ref;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(MuiDateSelector, [{
    key: 'shouldComponentUpdate',


    // eslint-disable-next-line no-unused-vars
    value: function shouldComponentUpdate(newProps, newState) {
      return this.state.selected !== newState.selected;
    }

    // eslint-disable-next-line no-unused-vars

  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      // Props.
      var _props = this.props,
          dates = _props.dates,
          onChange = _props.onChange;

      // States.

      var _state = this.state,
          selected = _state.selected,
          customRange = _state.customRange;


      if (prevState.selected !== selected && onChange) {
        if (selected >= 0) {
          var _dates$selected = _toArray(dates[selected]),

          // eslint-disable-next-line no-unused-vars
          _ = _dates$selected[0],
              rangeDates = _dates$selected.slice(1);

          // Notify date range selected.


          onChange(rangeDates);
        } else {
          onChange(customRange);
        }
      }
    }

    /**
     * Format of dates.
     */


    /**
     * Function triggered when a date is selected.
     *
     * @param {number} selected - The date index selected.
     */


    /**
     * Function used to get string dates.
     *
     * @param {object} fromDate - The date instance of moment.
     * @param {object} toDate   - The date instance of moment.
     *
     * @public
     */


    /**
     * Callback triggered when a custom date range is selected.
     *
     * @param {object} fromDate - The date instance of moment.
     * @param {object} toDate   - The date instance of moment.
     */


    /**
     * Set ref to range selector.
     *
     * @param {object} ref - The range selector ref.
     */

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      // Props.
      var _props2 = this.props,
          title = _props2.title,
          dates = _props2.dates,
          children = _props2.children,
          customDateSelectorTitle = _props2.customDateSelectorTitle;

      // States.

      var _state2 = this.state,
          selected = _state2.selected,
          customRange = _state2.customRange;


      var RangeSelector = void 0;

      _react2.default.Children.forEach(children, function (child) {
        if (!_react2.default.isValidElement(child)) return;

        var displayName = child.type.displayName;


        if (displayName === 'MuiDateRangePicker') RangeSelector = _react2.default.cloneElement(child, {
          onSelectedRange: _this2.onCustomRangeSelected,
          ref: _this2.rangeSelectorRef
        });
      });

      return _react2.default.createElement(
        _List.List,
        null,
        _react2.default.createElement(
          _Subheader2.default,
          null,
          title
        ),
        dates.map(function (_ref2, i) {
          var _ref3 = _slicedToArray(_ref2, 3),
              primaryText = _ref3[0],
              fromDate = _ref3[1],
              toDate = _ref3[2];

          return _react2.default.createElement(_List.ListItem, {
            key: i,
            primaryText: primaryText,
            leftIcon: selected === i ? _react2.default.createElement(_radioButtonChecked2.default, null) : _react2.default.createElement(_radioButtonUnchecked2.default, null),
            onClick: function onClick() {
              return _this2.selectDate(i);
            },
            secondaryText: _this2.listItemSecondaryText(fromDate, toDate)
          });
        }),
        RangeSelector && _react2.default.createElement(_List.ListItem, {
          primaryText: customDateSelectorTitle,
          leftIcon: selected < 0 ? _react2.default.createElement(_radioButtonChecked2.default, null) : _react2.default.createElement(_radioButtonUnchecked2.default, null),
          onClick: function onClick() {
            return _this2.rangeSelector.open();
          },
          secondaryText: customRange ? this.listItemSecondaryText.apply(this, _toConsumableArray(customRange)) : ''
        }),
        RangeSelector
      );
    }
  }]);

  return MuiDateSelector;
}(_react2.default.Component);

MuiDateSelector.propTypes = propTypes;
MuiDateSelector.defaultProps = defaultProps;

exports.default = MuiDateSelector;